#!/usr/bin/python3
# -*- coding: iso-8859-1 -*-

#leer comunicaciones mediante hilos
#SETA43
#seta43.duckdns.org

#   sudo apt-get install python-wxtools
#   pip install -U wxPython
#   apt install python3
#   apt install python3-pip
#   pip3 install pyserial

# usermod -a -G dialout,lock usuario
# chmod a+rw /dev/ttyUSB0

import wx
import time
import serial
import os
import sys

from threading import Thread

#Para Linux
puertos=['/dev/ttyUSB0','/dev/ttyUSB1','/dev/ttyACM0','/dev/ttyACM1','/dev/ttyACM2','/dev/ttyS0' ]
portOK=0;
namePort=""
DataSerial=""
DataState=0
ExitProgram=0


class MiHilo(Thread):
    def __init__ (self):
        Thread.__init__(self)
        self._want_abort = 0
        self.start()

    # Metodo que se ejecutara en un hilo
    def run (self):
        global portOK
        global arduinoPort
        global DataSerial
        global ExitProgram
        global DataState

        print("Hilo comunicaciones abierto")
        while(ExitProgram==0):
            if portOK==1:
                DataSerial = arduinoPort.readline()
                if len(DataSerial)>2:
                    DataSerial = DataSerial.rstrip(b'\r\n')
                    DataSerial = DataSerial.decode("utf-8")
                    #print(DataSerial)
                    DataState=1
            time.sleep(0.2)
        print("Hilo comunicaciones cerrado")
        return None

class MyApp(wx.App):
    def OnInit(self):
        frame = MyFrame("TERMINAL SERIE Thread", (50, 60), (470, 150))
        frame.Show()
        self.SetTopWindow(frame)
        return True

class MyFrame(wx.Frame):
    def __init__(self, title, pos, size):
        wx.Frame.__init__(self, None, -1, title, pos, size)

        self.botonConect = wx.Button(self,-1,label="Conectar",size=(100,26),pos=(10,10))
        self.botonExit = wx.Button(self,-1,label="EXIT",size=(100,26),pos=(340,80))
        self.etiqueta = wx.StaticText(self,-1,label=" Hola ARDUINO ",pos=(10,80))
        self.dato = wx.TextCtrl(self, -1,"-",size=(430, 26),pos=(10,50),style=wx.TE_READONLY)
        font1 = wx.Font(11, wx.MODERN, wx.NORMAL, wx.BOLD, False, u'Consolas')
        self.dato.SetFont(font1)
        self.dato.SetForegroundColour(wx.Colour(255,0,0))

        self.botonConect.Bind (wx.EVT_BUTTON, self.ExeBotonConect)
        self.botonExit.Bind (wx.EVT_BUTTON, self.ExeBotonExit)

        self.Combo1=wx.ComboBox(self, -1, "/dev/ttyUSB0", (150, 10), (130,26),puertos, wx.CB_DROPDOWN)
        self.Combo1.Bind (wx.EVT_COMBOBOX, self.ExeCombo1)

        self.MiTexto = wx.TextCtrl(self,value="---", pos=(300, 10), size=(140,26),style=wx.TE_READONLY )

        self.timer = wx.Timer(self)
        self.Bind(wx.EVT_TIMER, self.OnTimer)
        self.timer.Start(100)


    def OnTimer(self, event):
        global portOK
        global arduinoPort
        global DataState

        #if self.timer.IsRunning():
        self.timer.Stop()

        if DataState==1:
                self.dato.SetValue(DataSerial)
                DataState=0
        self.timer.Start(100)


    def ExeBotonConect(self,event):
        global namePort
        global portOK
        global arduinoPort
        global ExitProgram

        print ("Evento Conectar")

        if portOK==1:
            print("Puerto ya abierto_")
            return ()

        namePort=self.Combo1.GetValue()
        print(namePort)
        try:
            arduinoPort = serial.Serial(namePort, 9600, timeout=1)
            print(arduinoPort.is_open)
        except:
            print ("ERROR dispositivo " + namePort)
            self.MiTexto.SetValue("ERROR " + namePort)
            portOK=0
        else:
            print ("OK dispositivo " + namePort + " abierto")
            self.MiTexto.SetValue("OK " + namePort)
            hilo = MiHilo()
            portOK=1
            arduinoPort.flushInput()

    def ExeBotonExit(self,event):
        global portOK
        global arduinoPort
        global ExitProgram

        print ("Evento EXIT")
        ExitProgram=1
        portOK=0;
        time.sleep(0.5)

        try:
            arduinoPort.close()
        except:
            print ("Puerto no abierto")
        else:
            print ("Dispositivo " + namePort + " cerrado")

        print ("Programa finalizado")
        self.Close()

    def ExeCombo1(self,event):
        print ("Evento combo")
        self.MiTexto.SetValue(self.Combo1.GetValue())


if __name__ == '__main__':
    app = MyApp(False)
    app.MainLoop()

